package onebit.rlecodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class RLECodec {

  public static void main(String[] args) throws IOException {
    if (args.length >= 1) {
      String cmd = args[0];
      if ("encode".equalsIgnoreCase(cmd)) {
        OutputStream out = new RLEOutputStream(System.out);
        try {
          byte[] buf = new byte[1024];
          int count;
          while ((count = System.in.read(buf)) >= 0) {
            out.write(buf, 0, count);
          }
          out.flush();
        } finally {
          out.close();
        }
        System.exit(0);
        
      } else if ("decode".equalsIgnoreCase(cmd)) {
        InputStream in = new RLEInputStream(System.in);
        try {
          byte[] buf = new byte[1024];
          int count;
          while ((count = in.read(buf)) >= 0) {
            System.out.write(buf, 0, count);
          }
          System.out.flush();
        } finally {
          in.close();
        }
        System.exit(0);
      }
    }
    System.err.println("Usage: java " + RLECodec.class.getName() + " encode|decode < in > out");
    System.exit(1);
  }

}
