package onebit.rlecodec;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;


public class RLEInputStream extends FilterInputStream {

  int length;
  int data;
  
  public RLEInputStream(InputStream in) {
    super(in);
  }

  @Override
  public int available() throws IOException {
    return Math.abs(length);
  }

  @Override
  public int read(byte[] b, int off, int len) throws IOException {
    for (int i = 0; i < len; i++) {
      int d = read();
      if (d < 0) {
        return i > 0? i: -1;
      }
      b[off + i] = (byte)d;
    }
    return len;
  }
  
  @Override
  public int read() throws IOException {
    if (length == 0) {
      int d = super.read();
      if (d >= 0) {
        length = (byte)d;
        if (length >= 0) {
          length++;
        } else {
          d = super.read();
          if (d < 0) {
            throw new IOException("Stream exhausted prematurelly");
          } else {
            data = d;
          }
        }
      }
    }
    
    if (length > 0) {
      int d = super.read();
      if (d >= 0) {
        length--;
        return d;
      } else {
        throw new IOException("Stream exhausted prematurelly");
      }
      
    } else if (length < 0) {
      length++;
      return data;
    }
    
    return -1;
  }

  @Override
  public long skip(long n) throws IOException {
    for (long i = 0; i < n; i++) {
      int d = read();
      if (d < 0) {
        return i;
      }
    }
    return n;
  }

}
