package onebit.rlecodec;

import java.io.FilterOutputStream;
import java.io.IOException;
import java.io.OutputStream;

public class RLEOutputStream extends FilterOutputStream {

  byte[] buffer = new byte[128];
  int length;
  
  public RLEOutputStream(OutputStream out) {
    super(out);
  }

  @Override
  public void close() throws IOException {
    if (length > 0) {
      super.write(length-1);
      out.write(buffer, 0, length);
    } else if (length < 0) {
      super.write(length);
      super.write(buffer[0]);
    }
    super.close();
  }

  @Override
  public void write(int b) throws IOException {
    if (length > 0) {
      if ((byte)b != buffer[length-1]) {
        if (length >= 128) {
          super.write(length-1);
          out.write(buffer, 0, length);
          length = 0;
        }
        buffer[length++] = (byte)b;
      } else {
        if (length > 1) {
          super.write(length-2);
          out.write(buffer, 0, length-1);
        }
        buffer[0] = (byte)b;
        length = -2;
      }
      
    } else if (length < 0) {
      if ((byte)b == buffer[0]) {
        length--;
        if (length <= -128) {
          super.write(length);
          super.write(buffer[0]);
          length = 0;
        }
      } else {
        if (length < -1) {
          super.write(length);
          super.write(buffer[0]);
        }
        buffer[0] = (byte)b;
        length = 1;
      }
      
    } else {
      buffer[length++] = (byte)b;
    }
  }

}
